unit f_NamedProjectionsForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, f_OrbisForm, StdCtrls, ExtCtrls;

type
  TNamedProjections_Form = class(TORBISForm)
    ListBox: TListBox;
    Panel1: TPanel;
    Edit: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation
uses
   m_Orbis;

{$R *.dfm}

procedure TNamedProjections_Form.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   inherited;
   if Tool <> nil then
      Tool.PostMsg(tm_Hide,Tool,nil,false);
   CanClose := true;
end;

procedure TNamedProjections_Form.Button1Click(Sender: TObject);
var
   S: string;
begin
   S := Edit.Text;
   if S = '' then
   begin
      ShowMessage('Zadejte Nzev !');
      Edit.SetFocus;
      exit;
   end;
   if ListBox.Items.IndexOf(S) > -1 then
   begin
      ShowMessage('Nzev '+ S + ' ji existuje!');
      Edit.SetFocus;
      exit;
   end;
   if Tool <> nil then
      Tool.SetPropertyStringByName('NewNamedProjection',S);

end;

procedure TNamedProjections_Form.ListBoxClick(Sender: TObject);
var
   S: string;
begin
   if Listbox.ItemIndex < 0 then exit;
   S := ListBox.Items.Strings[ListBox.ItemIndex];
   if Tool <> nil then
      Tool.SetPropertyStringByName('ShowNamedProjection',S);
end;

procedure TNamedProjections_Form.Button2Click(Sender: TObject);
var
   S: string;
begin
   if Listbox.ItemIndex < 0 then exit;
   S := ListBox.Items.Strings[ListBox.ItemIndex];
   if Tool <> nil then
      Tool.SetPropertyStringByName('DeleteNamedProjection',S);
end;

end.

