unit f_LineDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls;

type
  TLineDialog_Form = class(TOrbisDialog_Form)
    b_DeletePoint: TBitBtn;
    b_Close: TBitBtn;
    b_DeleteLine: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    l_length: TLabel;
    l_Count: TLabel;
    SnapPanel: TPanel;
    Label3: TLabel;
    cb_SnapToLinePoint: TCheckBox;
    cb_SnapToLineBody: TCheckBox;
    cb_SnapToLine: TCheckBox;
    ed_SnapDistance: TEdit;
    b_Continue: TBitBtn;
    b_CreateCopy: TBitBtn;
    BitBtn1: TBitBtn;
    b_Swap: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure cb_SnapToLineClick(Sender: TObject);
  private
    { Private declarations }
  public
     procedure CHeckSnap;
    { Public declarations }
  end;


implementation

{$R *.DFM}

procedure TLineDialog_Form.CHeckSnap;
begin
   cb_SnapToLinePoint.Enabled := cb_SnapToLine.Checked;
   cb_SnapToLineBody.Enabled := cb_SnapToLine.Checked;
   ed_SnapDistance.Enabled := cb_SnapToLine.Checked;
end;

procedure TLineDialog_Form.FormShow(Sender: TObject);
begin
   inherited;
   b_OK.SetFocus;
end;

procedure TLineDialog_Form.cb_SnapToLineClick(Sender: TObject);
begin
   CheckSnap;
end;

end.
