unit u_xestring;

interface

type


{$IF RTLVersion >= 22}   // XE
_xChar  = Ansichar;
P_xChar = PAnsiChar;
_xString = Ansistring;
function _xChr(Value: Byte):AnsiChar;
{$ELSE}
_xChar  = char;
P_xChar = PChar;
_xString = string;
function _xChr(Value: Byte):Char;
{$IFEND}
function _xDecimalSeparator: _xChar;


implementation
uses
   SysUtils;

{$IF RTLVersion >= 22}   // XE
function _xChr(Value: Byte):AnsiChar;
begin
   result := AnsiChar(chr(Value));
end;
{$ELSE}
function _xChr(Value: Byte):Char;
begin
   result := chr(Value);
end;
{$ENDIF}
function _xDecimalSeparator: _xChar;
begin
{$IF RTLVersion >= 27}   // XE6
   result := _xChar(FormatSettings.DecimalSeparator);
{$ELSE}
   result := _xChar(DecimalSeparator);
{$ENDIF}
end;




end.
