unit f_ExportLHCDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls;

type
  TExportLHCDialog_Form = class(TOrbisDialog_Form)
    ed_BlockName: TEdit;
    Label1: TLabel;
    b_TEZ: TSpeedButton;
    c_Backup: TCheckBox;
    ed_Backup: TEdit;
    Label3: TLabel;
    ed_ControlDirectory: TEdit;
    Label4: TLabel;
    c_ControlDirectory: TSpeedButton;
    procedure b_TEZClick(Sender: TObject);
    procedure c_ControlDirectoryClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation
uses
   FileCtrl;

{$R *.DFM}

procedure TExportLHCDialog_Form.b_TEZClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_BlockName.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_BlockName.Text := S;
   end;
end;

procedure TExportLHCDialog_Form.c_ControlDirectoryClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_ControlDirectory.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_ControlDirectory.Text := S;
   end;
end;

end.
