unit F_bmpdlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, FileCtrl;

type
  TNewBMPDlg = class(TForm)
    Panel: TPanel;
    b_OK: TBitBtn;
    b_Cancel: TBitBtn;
    Panel2: TPanel;
    Directory: TDirectoryListBox;
    FileList: TFileListBox;
    Image: TImage;
    Drive: TDriveComboBox;
    procedure FormResize(Sender: TObject);
    procedure FileListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation
uses
// KERNEL
   u_String;

{$R *.DFM}

procedure TNewBMPDlg.FormResize(Sender: TObject);
begin
   FileList.Height := Panel2.Height - 133;
end;

procedure TNewBMPDlg.FileListClick(Sender: TObject);
begin
   Image.Picture.LoadFromFile(FileList.FileName);
end;

procedure TNewBMPDlg.FormCreate(Sender: TObject);
begin
   FileList.Mask := GraphicFileMask(TGraphic);
end;

end.
