unit U_hdtest;

interface

function GetSystemHDSerialNumer: integer;

implementation

{$IFDEF MSWINDOWS}
uses
   WinProcs;
function GetSystemHDSerialNumer: integer;
var
{
    LPCTSTR  lpRootPathName,	// address of root directory of the file system
    LPTSTR  lpVolumeNameBuffer,	// address of name of the volume
    DWORD  nVolumeNameSize,	// length of lpVolumeNameBuffer
    LPDWORD  lpVolumeSerialNumber,	// address of volume serial number
    LPDWORD  lpMaximumComponentLength,	// address of system's maximum filename length
    LPDWORD  lpFileSystemFlags,	// address of file system flags
    LPTSTR  lpFileSystemNameBuffer,	// address of name of file system
    DWORD  nFileSystemNameSize 	// length of lpFileSystemNameBuffer
}
   //res: boolean;
   PRoot, PVolumeName, PFileSystem: PChar;
   SRoot, SVolumeName, SFileSystem: Array[0..300] of char;
   SerialNumber,AdressLength, Flags: DWORD;
   {**************************}
   { verze #3}
   {**************************}
begin
   PRoot := @SRoot;
   PFileSystem := @SFileSystem;
   PVolumeName := @SVolumeName;
   SRoot := 'C:\'+#0;
   {res := }GetVolumeInformation(PRoot, PVolumeName, 300, @SerialNumber, AdressLength, Flags, PFileSystem, 300);
   {$RANGECHECKS OFF}
   result := SerialNumber;
end;



{$ELSE}
uses
   WinProcs;

type


TDiskInfo = record
   Zero:         word;                 { ??? (zero)}
   SerialNumber: longInt;              { disk serial number (binary)}
   VolumeLabel:  array[0..10] of char; { volume label or "NO NAME    " if none present }
   FatTypeString: array[0..7] of char; { FAT type--string "FAT12   " or "FAT16   " }
end;

var
  DiskInfo: TDiskInfo;



procedure CheckDiskC; assembler;
asm
   mov   AH,69h
   mov   AL,00h
   mov   BL,3
   mov   dx,offset DiskInfo
   call  Dos3Call
end;

function GetSystemHDSerialNumer: longInt;
begin
   CheckDiskC;
   result := DiskInfo.SerialNumber;
end;


{$ENDIF}

end.
