unit f_Test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  {XMLDOc, }ExtCtrls, Spin;

type

  TThread1 = class;

  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    Label3: TLabel;
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Button5: TButton;
    Button6: TButton;
    Edit2: TEdit;
    Button9: TButton;
    SpinEdit1: TSpinEdit;
    Button7: TButton;
    Button8: TButton;
    comp: TButton;
    Button10: TButton;
    Button11: TButton;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure FormConstrainedResize(Sender: TObject; var MinWidth,
      MinHeight, MaxWidth, MaxHeight: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure compClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    //FXML: TXMLDocument;
    //procedure SetXML(const Value: TXMLDocument);
    { Private declarations }
    FThread: TThread1;
  public
     //property XML: TXMLDocument read FXML write SetXML;
       procedure SelfCreate;
  end;

 TThread1 = class(TThread)
 private
    FForm: TForm1;
 protected
     procedure Execute; override;
 public
    FForm2: TForm1;
 end;

var
  Form1: TForm1;
  FFForm : TForm1;

implementation
uses
   m_Orbis,
   e_Color,
   e_Pale,
   t_Main,
   Worlds,
   Math,
   u_String,
   t_XML, Elements;

const
  CXlsBof: array[0..5] of Word = ($809, 8, 00, $10, 0, 0);
  CXlsEof: array[0..1] of Word = ($0A, 00);
  CXlsLabel: array[0..5] of Word = ($204, 0, 0, 0, 0, 0);
  CXlsNumber: array[0..4] of Word = ($203, 14, 0, 0, 0);
  CXlsRk: array[0..4] of Word = ($27E, 10, 0, 0, 0);

{$R *.dfm}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
end;
(*
procedure TForm1.SetXML(const Value: TXMLDocument);
begin
  FXML := Value;
end;
*)
procedure TForm1.Button4Click(Sender: TObject);
var
   blb: TMultiReadExclusiveWriteSynchronizer;

begin
   blb := TMultiReadExclusiveWriteSynchronizer.Create;
   blb.BeginWrite;
   blb.BeginRead;
   FThread := TThread1.Create(true);
   FThread.FForm2 := Self;
   FThread.Resume;
   blb.EndRead;
   blb.EndWrite;
   blb.Free;
   (*
   if OpenDialog1.Execute then
   begin
      XML.LoadFromFile(OpenDialog1.FileName);
      Memo1.Lines.Assign(XML.XML);
   end;
   *)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   //XML := TXMLDocument.Create(Application);
end;

// XLS without ole

procedure XlsBeginStream(XlsStream: TStream; const BuildNumber: Word);
begin
  CXlsBof[4] := BuildNumber;
  XlsStream.WriteBuffer(CXlsBof, SizeOf(CXlsBof));
end;

procedure XlsEndStream(XlsStream: TStream);
begin
  XlsStream.WriteBuffer(CXlsEof, SizeOf(CXlsEof));
end;

procedure XlsWriteCellRk(XlsStream: TStream; const ACol, ARow: Word; const AValue: Integer);
var
  V: Integer;
begin
  CXlsRk[2] := ARow;
  CXlsRk[3] := ACol;
  XlsStream.WriteBuffer(CXlsRk, SizeOf(CXlsRk));
  V := (AValue shl 2) or 2;
  XlsStream.WriteBuffer(V, 4);
end;

procedure XlsWriteCellNumber(XlsStream: TStream; const ACol, ARow: Word; const AValue: Double);
begin
  CXlsNumber[2] := ARow;
  CXlsNumber[3] := ACol;
  XlsStream.WriteBuffer(CXlsNumber, SizeOf(CXlsNumber));
  XlsStream.WriteBuffer(AValue, 8);
end;

procedure XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word; const AValue: string);
var
  L: Word;
begin
  L := Length(AValue);
  CXlsLabel[1] := 8 + L;
  CXlsLabel[2] := ARow;
  CXlsLabel[3] := ACol;
  CXlsLabel[5] := L;
  XlsStream.WriteBuffer(CXlsLabel, SizeOf(CXlsLabel));
  XlsStream.WriteBuffer(Pointer(AValue)^, L);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  FStream: TFileStream;
  I, J: Integer;
begin
  FStream := TFileStream.Create('c:\dokumenty\e_test.xls', fmCreate);
  try
    XlsBeginStream(FStream, 0);
    for I := 0 to 99 do
      for J := 0 to 99 do
      begin
       //XlsWriteCellNumber(FStream, I, J, 34.34);
       // XlsWriteCellRk(FStream, I, J, 3434);
        XlsWriteCellLabel(FStream, I, J, Format('Cell: %d,%d', [I, J]));
      end;
    XlsEndStream(FStream);
  finally
    FStream.Free;
  end;
end;
// XLS END


procedure TForm1.Button3Click(Sender: TObject);
var
   X: TXMLTool;
begin
   X := TXMLTool.Create;
   Memo1.Lines.Add(X.XMLToStr(Edit1.Text));
   X.Free;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
   X: TXMLTool;
begin
   X := TXMLTool.Create;
   Memo1.Lines.Add(X.StrToXML(Edit1.Text));
   X.Free;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
   D: double;
begin
   D := StrToFloat(Edit2.Text);
   D := SimpleRoundTo(D,SpinEdit1.Value);
   Edit2.Text := FloatToStr(D);

end;

procedure TForm1.Button1Click(Sender: TObject);
var
   i: integer;
begin
   i := 0;
   repeat
      i := i + 1;
      if i mod 1000 = 0 then
      begin
         TMainTool(World.MainTool).Text := IntToStr(i);
      end;
      Application.ProcessMessages;
   until i > 100000;
   ShowMessage('Hotovo');
end;

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
   World.MainTool.PostTextMsg(tm_AddToProtocol,'CanResize',nil);
   Resize := true;
   Application.ProcessMessages;
end;

procedure TForm1.FormConstrainedResize(Sender: TObject; var MinWidth,
  MinHeight, MaxWidth, MaxHeight: Integer);
begin
   World.MainTool.PostTextMsg(tm_AddToProtocol,'ConstrainedResize',nil);
   Application.ProcessMessages;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   World.MainTool.PostTextMsg(tm_AddToProtocol,'Resize',nil);
   Application.ProcessMessages;
end;

{ TThread1 }

procedure TThread1.Execute;
//var
   //blb: TMultiReadExclusiveWriteSynchronizer;

begin
   FForm2.SelfCreate;
   (*
   //blb := TMultiReadExclusiveWriteSynchronizer.Create;
   //blb.BeginWrite;
   FForm := TForm1.Create(Application);
   FForm.Caption := 'jsem to j';
   FForm.Left := 20;
   FForm.Top := 20;
   FForm.Visible := true;
   //blb.EndWrite;
   ShowMessage('je videt');
   //blb.Free;
   *)
end;

procedure TForm1.SelfCreate;
begin
   FFForm := TForm1.Create(Application);
   FFForm.Caption := 'jsem to j';
   FFForm.Left := 20;
   FFForm.Top := 20;
   FFForm.Visible := true;
   //blb.EndWrite;
   ShowMessage('je videt');
   FFForm.Free;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   ShowMessage('Destroj');
end;

procedure TForm1.Button7Click(Sender: TObject);
var
   i: integer;
begin
   i := RomeToInteger(Edit1.Text);
   Memo1.Lines.Add(IntToStr(i));
end;

procedure TForm1.Button8Click(Sender: TObject);
var
   i: integer;
begin
   i := StrToIntDef(Edit1.Text,0);
   Memo1.Lines.Add(IntegerToRome(i));
end;

procedure TForm1.compClick(Sender: TObject);
var
   S: string;
   b: boolean;
   i: DWORD;
begin
   SetLength(S,150);
   i := 150;
   b := GetComputerName(PChar(S),i);
   if b then
      Memo1.Lines.Add(S)
   else
      Memo1.Lines.Add('Hyba!');
end;


function HHelp(hwndCaller : HWND; pszFile: PChar; uCommand : Integer;
            dwData : DWORD) : HWND; stdcall; external 'hhctrl.ocx' name 'HtmlHelpA';



procedure TForm1.Button10Click(Sender: TObject);
var
   aResult: HWND;
   aHelpFile: string;
begin
   aHelpFile := 'C:\docbook\Guide\tdg-en-2.0.9.chm';
   aResult := HHelp(GetDesktopWindow, PChar(aHelpFile + '::/htmlhelp/' + Edit1.Text + '.html'),  0,0);
end;

procedure TForm1.Button11Click(Sender: TObject);
var
   Pal: TColorPalette;
   i,bi: integer;
   T,T1: cardinal;

   function DejColor(aColor: integer): Integer;
   begin
      result := 0;
      if aColor >= 0 then
      begin
         result := Pal.Color[aColor];
      end;
   end;
begin
   // create the big palette
   Pal := TColorPalette.Create;
   for i  := 0 to 100 do
      Pal.NextColor := i*10;
   // default palette test
   T := GetTickCount;
   for i := 0 to 1000000 do
   begin
      bi := RandomRange(0,15);
      bi := DejBarvicku(bi);
   end;
   T1 := GetTickCount;
   Memo1.Lines.Add(IntToStr(T1-T)+' Default');
   // dynamic palette test
   T := GetTickCount;
   for i := 0 to 1000000 do
   begin
      bi := RandomRange(0,15);
      bi := DejColor(bi);
   end;
   T1 := GetTickCount;
   Memo1.Lines.Add(IntToStr(T1-T)+' Dynamic');
   Memo1.Lines.Add(' ');
   Pal.Free;
end;

INITIALIZATION

END.

