unit e_Project;

interface
uses
   Elements;

type

TOrbisProject = class(TOwnerEntity)
private
   FComment: string;
   FAuthor: string;
   procedure SetAuthor(const Value: string);
   procedure SetComment(const Value: string);
published
   property Author: string read FAuthor write SetAuthor;
   property Comment: string read FComment write SetComment;
end;

TOrbisProjects = class(TOwnerEntity)
end;


implementation
uses
   e_Class;

{ TOrbisProject }

procedure TOrbisProject.SetAuthor(const Value: string);
begin
   FAuthor := Value;
end;

procedure TOrbisProject.SetComment(const Value: string);
begin
   FComment := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TOrbisProject);
END.
