unit r_ScaleMonitor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  r_OrbisFrame, StdCtrls, Buttons;

type
  TScaleMonitor_Frame = class(TOrbis_Frame)
    ed_Scale: TComboBox;
    ed_VirtualScale: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation
uses
   m_Orbis,
   t_Device;

{$R *.DFM}

procedure TScaleMonitor_Frame.BitBtn1Click(Sender: TObject);
begin
   if TDeviceTool(Tool).Device = nil then exit;
   TDeviceTool(Tool).Device.Projection.SetPropertyStringByName('Scale',ed_Scale.Text);
   Tool.PostMsgToOwners(tm_BreakAndReView,nil,false);
   Tool.PostMsgToOwners(tm_ProjectionChanged,TDeviceTool(Tool).Device.Projection,false);
end;

procedure TScaleMonitor_Frame.BitBtn2Click(Sender: TObject);
begin
   if TDeviceTool(Tool).Device = nil then exit;
   TDeviceTool(Tool).Device.Projection.SetPropertyStringByName('VirtualScale',ed_VirtualScale.Text);
   Tool.PostMsgToOwners(tm_BreakAndReView,nil,false);
   Tool.PostMsgToOwners(tm_ProjectionChanged,TDeviceTool(Tool).Device.Projection,false);
end;

end.
