unit U_cursor;

interface

const
cr_Lupa        = 1;
cr_Ruka        = 2;
cr_NewDrawRect = 3;
cr_NewText     = 4;
cr_NewView     = 5;
cr_NewUMS      = 6;
cr_EditUMS     = 7;
cr_NoUMS       = 8;
cr_NoElement   = 9;
cr_NewTxtBlk   = 10;
cr_EditText    = 11;
cr_ZoomIn      = 12;
cr_ZoomOut     = 13;
cr_MoveText    = 14;
cr_RotText     = 15;
cr_MoveCenter  = 16;
cr_SelectLine  = 17;
cr_SelectArea  = 18;
cr_SelectPoint = 19;
cr_NewBMP      = 20;

cr_Insert_Point = 21;
cr_Move_Point = 22;

procedure LoadUserCursors;



implementation
uses
   Forms,
   WinProcs;

{$R CURS32.RES}

procedure LoadUserCursors;
var
{$IFDEF UNICODE}
   S: UnicodeString;
   function LoadCurs(hinst: cardinal; curnam : unicodestring): HICON;
   begin
      result := LoadCursor(hinst, PWidechar(curnam));
   end;
{$ELSE}
   S: string;
   function LoadCurs(hinst: cardinal; curnam : string): HICON;
   begin
      result := LoadCursor(hinst, curnam);
   end;
{$ENDIF}
begin
   S := 'LUPA';
   Screen.Cursors[cr_Lupa]        := LoadCurs(HInstance, S);
   S := 'RUKA';
   Screen.Cursors[cr_Ruka]        := LoadCurs(HInstance, S);
   S := 'NEWDRAWRECT';
   Screen.Cursors[cr_NewDrawRect] := LoadCurs(HInstance, S);
   S := 'NEWTEXT';
   Screen.Cursors[cr_NewText]     := LoadCurs(HInstance, S);
   S := 'NEWBMP';
   Screen.Cursors[cr_NewBMP]      := LoadCurs(HInstance, S);
   S := 'EDITTEXT';
   Screen.Cursors[cr_EditText]    := LoadCurs(HInstance, S);
   S := 'MOVETEXT';
   Screen.Cursors[cr_MoveText]    := LoadCurs(HInstance, S);
   S := 'ROTTEXT';
   Screen.Cursors[cr_RotText]     := LoadCurs(HInstance, S);
   S := 'NEWVIEW';
   Screen.Cursors[cr_NewView]     := LoadCurs(HInstance, S);
   S := 'NEWMS';
   Screen.Cursors[cr_NewUMS]      := LoadCurs(HInstance, S);
   S := 'EDITMS';
   Screen.Cursors[cr_EditUMS]     := LoadCurs(HInstance, S);
   S := 'NOMS';
   Screen.Cursors[cr_NoUMS]       := LoadCurs(HInstance, S);
   S := 'NOTFORSELECT';
   Screen.Cursors[cr_NoElement]   := LoadCurs(HInstance, S);
   S := 'NEWTEXTBLOCK';
   Screen.Cursors[cr_NewTxtBlk]   := LoadCurs(HInstance, S);
   S := 'ZOOM_IN';
   Screen.Cursors[cr_ZoomIn]      := LoadCurs(HInstance, S);
   S := 'ZOOM_OUT';
   Screen.Cursors[cr_ZoomOut]     := LoadCurs(HInstance, S);
   S := 'MOVECENTER';
   Screen.Cursors[cr_MoveCenter]  := LoadCurs(HInstance, S);
   S := 'SELECTLINE';
   Screen.Cursors[cr_SelectLine]  := LoadCurs(HInstance, S);
   S := 'SELECTAREA';
   Screen.Cursors[cr_SelectArea]  := LoadCurs(HInstance, S);
   S := 'SELECTPOINT';
   Screen.Cursors[cr_SelectPoint] := LoadCurs(HInstance, S);
   S := 'INSERT_POINT';
   Screen.Cursors[cr_Insert_Point] := LoadCurs(HInstance, S);
   S := 'MOVE_POINT';
   Screen.Cursors[cr_Move_Point] := LoadCurs(HInstance, S);
end;

end.
