unit e_TMPText;

interface
uses
   g_Elems;

type

TtmpText = class(TRectEntity)
  private
    FFontStyle: byte;
    FTextAngle: double;
    FTextHeight: double;
    FTextColor: integer;
    FFontCode: integer;
    FText: string;
    FFontName: string;
    FTextSize: double;
    procedure SetFontCode(const Value: integer);
    procedure SetFontName(const Value: string);
    procedure SetFontStyle(const Value: byte);
    procedure SetText(const Value: string);
    procedure SetTextAngle(const Value: double);
    procedure SetTextColor(const Value: integer);
    procedure SetTextHeight(const Value: double);
    procedure SetTextSize(const Value: double);
published
   property Text: string read FText write SetText;
   property FontCode: integer read FFontCode write SetFontCode;
   property FontName: string read FFontName write SetFontName;
   property FontStyle:  byte read FFontStyle write SetFontStyle;
   property TextColor: integer read FTextColor write SetTextColor;
   property TextHeight: double read FTextHeight write SetTextHeight;
   property TextSize: double read FTextSize write SetTextSize;
   property TextAngle: double read FTextAngle write SetTextAngle;
   //property tmpX: double;
   //property tmpY: double;
end;

implementation
uses
   e_Class;

{ TtmpText }

procedure TtmpText.SetFontCode(const Value: integer);
begin
  FFontCode := Value;
end;

procedure TtmpText.SetFontName(const Value: string);
begin
  FFontName := Value;
end;

procedure TtmpText.SetFontStyle(const Value: byte);
begin
  FFontStyle := Value;
end;

procedure TtmpText.SetText(const Value: string);
begin
  FText := Value;
end;

procedure TtmpText.SetTextAngle(const Value: double);
begin
  FTextAngle := Value;
end;

procedure TtmpText.SetTextColor(const Value: integer);
begin
  FTextColor := Value;
end;

procedure TtmpText.SetTextHeight(const Value: double);
begin
  FTextHeight := Value;
end;

procedure TtmpText.SetTextSize(const Value: double);
begin
  FTextSize := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TtmpText);
END.
