unit e_Group;

interface
uses
   Elements;

type

TGroup = class(TOwnerEntity)
public
   procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
end;

implementation
uses
   e_Class;

{ TGroup }

procedure TGroup.HandleMessage(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   i: longInt;
   E: TElement;
begin
   if NoElements then Exit;
   for i := 0 to LastIndex do
   begin
      E := Elements[i];
      if E <> aMessage.Sender then
      begin
         E.HandleMessage(aMessage, Handled);
      end;
      if Handled then break;
   end;
end;

INITIALIZATION
   RegisterOrbisClass(TGroup);
END.
