unit f_KatastrPDialog;

interface
{$I ..\_conditions.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls,
  e_KatastrModel, Grids;

type
  TKatastrPDialog_Form = class(TOrbisDialog_Form)
    Panel4: TPanel;
    l_PAR_Plocha: TLabel;
    l_PAR_Vymera: TLabel;
    l_Area: TLabel;
    Label7: TLabel;
    Label17: TLabel;
    BitBtn1: TBitBtn;
    Panel_skupina: TPanel;
    l_Vlastnik: TLabel;
    l_SKP: TLabel;
    l_KU: TLabel;
    l_Katpar_KOD: TLabel;
    ed_Vlastnik: TComboBox;
    ed_SkParc: TComboBox;
    ed_KU: TComboBox;
    ed_Kategorie: TComboBox;
    Panel_Parcela: TPanel;
    ed_Cislo: TEdit;
    ed_Podlomeni: TEdit;
    Label1: TLabel;
    l_PARCIS: TLabel;
    l_PARPOD: TLabel;
    PanelAreaOnly: TPanel;
    cb_AreaOnly: TCheckBox;
    Label9: TLabel;
    l_AreaCount: TLabel;
    ed_Parcela: TComboBox;
    ed_Vymera: TEdit;
    PanelDynamic: TPanel;
    SG: TStringGrid;
    ed_LV: TEdit;
    l_LV: TLabel;
    cb_Stavebni: TCheckBox;
    cb_PUPFL: TCheckBox;
    cb_PARZAR: TCheckBox;
    ed_LVC: TEdit;
    l_LVC: TLabel;
    ed_PKCis: TEdit;
    Label8: TLabel;
    ed_PKPod: TEdit;
    l_PKCIS: TLabel;
    l_PKPOD: TLabel;
    ed_Kultura: TEdit;
    l_Kultura: TLabel;
    l_Plocha: TLabel;
    l_pcArea: TLabel;
    Label21: TLabel;
    l_Vymera: TLabel;
    ed_PCVymera: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    l_pcNumber: TLabel;
    ed_SuperID: TEdit;
    l_SuperID: TLabel;
    cb_PUPFLc: TCheckBox;
    cb_IsKUMajitel: TCheckBox;
    l_KUNazev: TLabel;
    l_MajName: TStaticText;
    ed_PK_Dil: TEdit;
    l_PKDIL: TLabel;
    cb_GP: TCheckBox;
    l_PAR_SKU_KN: TLabel;
    l_PARSKUKN: TLabel;
    cb_NEP: TCheckBox;
    ed_Poznamka: TEdit;
    l_Poznamka: TLabel;
    l_KATUZE_KOD_PUV: TLabel;
    ed_KATUZE_KOD_PUV: TEdit;
    ed_ATR_PUV: TEdit;
    l_ATR_PUV: TLabel;
    ed_OLH: TComboBox;
    ed_OLH_PR_TIT: TEdit;
    l_OLH: TLabel;
    l_OLH_PR_TIT: TLabel;
    procedure FormShow(Sender: TObject);
    procedure ed_KUClick(Sender: TObject);
    procedure ed_SkParcClick(Sender: TObject);
    procedure ed_ParcelaClick(Sender: TObject);
    procedure ed_CisloChange(Sender: TObject);
    procedure cb_StavebniClick(Sender: TObject);
    procedure ed_VlastnikChange(Sender: TObject);
    procedure cb_GPClick(Sender: TObject);
    procedure cb_NEPClick(Sender: TObject);
    procedure ed_KATUZE_KOD_PUVChange(Sender: TObject);
    procedure ed_OLHChange(Sender: TObject);
  private
    FNewObject: boolean;
    FPModel: Tgis_ParcelModel;
    FOnlyPSKManipulate: boolean;
    FMajitele: Tgis_Majitele;
    FOLHs: TGis_OLHs;
    procedure SetNewObject(const Value: boolean);
    procedure SetPModel(const Value: Tgis_ParcelModel);
    procedure SetOnlyPSKManipulate(const Value: boolean);
    procedure SetDynamicProps(const Value: TStringList);
    procedure SetMajitele(const Value: Tgis_Majitele);
    procedure SetOLHs(const Value: TGis_OLHs);
  public
     procedure SetDynamicProp(aName,aValue: string);
     function  GetDynamicProp(aName: string): string;
     procedure FillParskukn;
     property PModel: Tgis_ParcelModel read FPModel write SetPModel;
     property Majitele: Tgis_Majitele read FMajitele write SetMajitele;
     property OLHs: TGis_OLHs read FOLHs write SetOLHs;
     property NewObject: boolean read FNewObject write SetNewObject;
     property OnlyPSKManipulate: boolean read FOnlyPSKManipulate write SetOnlyPSKManipulate;
     property DynamicProps: TStringList write SetDynamicProps;
  end;


implementation
uses
   Elements;
{$R *.DFM}

{ TKatastrPDialog_Form }

procedure TKatastrPDialog_Form.SetNewObject(const Value: boolean);
begin
  FNewObject := Value;
end;

procedure TKatastrPDialog_Form.SetPModel(const Value: Tgis_ParcelModel);
begin
  FPModel := Value;
end;

procedure TKatastrPDialog_Form.FormShow(Sender: TObject);
var
   i: integer;
   al: integer;
   al1: integer;
   aT: integer;
   aD: integer;
begin
   SG.Height := SG.DefaultRowHeight*SG.RowCount+(SG.RowCount)+4;
   SG.ColWidths[1]:=250;
{$IFDEF UHUL}
   Panel_Parcela.Height := 240;
   al := 10;
   al1 := 100;
   aT := 15;
   aD := 20;
   l_PARCIS.Left := al;
   l_PARCIS.Top  := aT;
   ed_Cislo.Left := al1;
   ed_Cislo.Top  := aT-5;
   aT := aT + aD;
   l_PARPOD.Left := al;
   l_PARPOD.Top  := aT;
   ed_Podlomeni.Left := al1;
   ed_Podlomeni.Top  :=  aT-5;
   ed_Parcela.Left := al1;
   ed_Parcela.Top := aT-5;
   aT := aT + aD;
   l_LV.Left := al;
   l_LV.Top  := aT;
   ed_LV.Left := al1;
   ed_LV.Top  := aT-5;
   aT := aT + aD;
   l_Kultura.Left := al;
   l_Kultura.Top  := aT;
   ed_Kultura.Left := al1;
   ed_Kultura.Top  := aT-5;
   aT := aT + aD;
   l_PKCIS.Left := al;
   l_PKCIS.Top  := aT;
   ed_PKCIS.Left := al1;
   ed_PKCIS.Top  := aT-5;
   aT := aT + aD;
   l_PKPOD.Left := al;
   l_PKPOD.Top  := aT;
   ed_PKPOD.Left := al1;
   ed_PKPOD.Top  := aT-5;
   aT := aT + aD;
   l_PKDIL.Left := al;
   l_PKDIL.Top  := aT;
   ed_PK_DIL.Left := al1;
   ed_PK_DIL.Top  := aT-5;
   aT := aT + aD;
   l_LVC.Left := al;
   l_LVC.Top  := aT;
   ed_LVC.Left := al1;
   ed_LVC.Top  := aT-5;
   aT := aT + aD;
   l_SuperID.Left := al;
   l_SuperID.Top  := aT;
   ed_SuperID.Left := al1;
   ed_SuperID.Top  := aT-5;
   aT := aT + aD;
   l_Poznamka.Top  := aT;
   ed_Poznamka.Top  := aT-5;
   cb_GP.Left := l_PAR_SKU_KN.Left;
   cb_GP.Top := l_PAR_SKU_KN.Top + aD;
   cb_NEP.Left := l_PAR_SKU_KN.Left;
   cb_NEP.Top := cb_GP.Top + aD;
   aT := aT + aD;
   l_KATUZE_KOD_PUV.Top := aT;
   l_KATUZE_KOD_PUV.Left := al;
   ed_KATUZE_KOD_PUV.Top := aT - 5;
   ed_KATUZE_KOD_PUV.Left := al1;
{$ENDIF}
   AutoSize := false;
   Application.ProcessMessages;
   AutoSize := true;
   Application.ProcessMessages;
   ed_Vlastnik.Font.Color := clWindowText;
   ed_OLH.Font.Color := clWindowText;
   if PModel = nil then exit;
   ed_KU.Items.Clear;
   for i := 0 to PModel.LastIndex do
      ed_KU.Items.Add(PModel.Elements[i].Name);
   if PModel.ActualKatastr <> nil then
   begin
      ed_KU.Text := PModel.ActualKatastr.Name;
      //!!!!!!!!!!!!
      if PModel.ActualSkupinaParcel <> nil then
         ed_SkParc.Text := PModel.ActualSkupinaParcel.Name;
      ed_KUClick(nil);
      ed_SkParcClick(nil);
   end
   else
   if not NewObject then
   begin
      ed_KU.Text := '';
      ed_SkParc.Text := '';
      //ed_Skupina.Text := FModel.ActualSkupina.Name;
   end;
end;

procedure TKatastrPDialog_Form.ed_KUClick(Sender: TObject);
var
   i: integer;
   //ki,kki: integer;
   vi,vvi: integer;
   e: TElement;
begin
   ed_SkParc.Items.Clear;
   ed_Parcela.Items.Clear;
   vi := 0;
   if Sender <> nil then
      PModel.Katastr_Cislo := StrToInt(ed_KU.Text);
   if OnlyPSKManipulate then
   begin
      //ki := StrToIntDef(ed_Kategorie.Text,0);
      vi := StrToIntDef(ed_Vlastnik.Text,0);
   end;
   if (PModel.ActualKatastr <> nil) and not PModel.ActualKatastr.NoSkupinaParcel then
   for i := 0 to PModel.ActualKatastr.SkupinyParcel.LastIndex do
   begin
      if OnlyPSKManipulate then
      begin
         //kki :=PModel.ActualKatastr.SkupinyParcel.elements[i].GetPropertyLongIntByName('KATPAR_KOD');
         vvi :=PModel.ActualKatastr.SkupinyParcel.elements[i].GetPropertyLongIntByName('VLASTNIK');
         if {(kki = ki) and }(vvi = vi) then
            ed_SKParc.Items.Add(PModel.ActualKatastr.SkupinyParcel.elements[i].Name);
      end
      else
         ed_SKParc.Items.Add(PModel.ActualKatastr.SkupinyParcel.elements[i].Name);
   end;
   if (PModel.ActualKatastr <> nil) and not PModel.ActualKatastr.NoParcela then
   for i := 0 to PModel.ActualKatastr.Parcely.LastIndex do
   begin
      if Panel_Parcela.Visible then
      begin
         e := PModel.ActualKatastr.Parcely.elements[i];
         ed_Parcela.Items.AddObject(e.Name,e);
      end;
   end;
   if Sender <> nil then
   begin
      ed_SKParc.Text := '';
   end;
   if (PModel.ActualKatastr <> nil) then
      l_KUNazev.Caption := PMOdel.ActualKatastr.Nazev
   else
      l_KUNazev.Caption := '.....';
end;

procedure TKatastrPDialog_Form.ed_OLHChange(Sender: TObject);
var
   S: string;
   i: integer;
   O: Tgis_OLH;
begin
   S := ed_OLH.Text;
   //i := StrToIntDef(S,0);
   if (S = '') or (S = '0')  then
   begin
      ed_OLH.Font.Color := clRed;
      ed_OLH_PR_TIT.Text := '';
//      l_MajName.Caption := '.....';
   end
   else
   if OLHs <> nil then
   begin
      O := OLHS.GetOLH_ID(S);
      if O = nil then
      begin
         ed_OLH.Font.Color := clLime;
//         ed_OLH_PR_TIT.Text := '';
      end
      else
      begin
         ed_OLH.Font.Color := clWindowText;
         ed_OLH_PR_TIT.Text := O.OLH_PR_TIT;
      end;
   end;
end;

procedure TKatastrPDialog_Form.ed_SkParcClick(Sender: TObject);
var
   i: integer;
   e: TElement;
begin
   //ed_Parcela.Items.Clear;
   if Sender <> nil then
      PModel.SkupinaParcel_Cislo := StrToInt(ed_SkParc.Text);
   {
   if (PModel.ActualSkupinaParcel <> nil) and not PModel.ActualSkupinaParcel.NoParcela then
   for i := 0 to PModel.ActualSkupinaParcel.Parcely.LastIndex do
   begin
      e := PModel.ActualSkupinaParcel.Parcely.elements[i];
      ed_Parcela.Items.AddObject(e.Name,e);
   end;
   }
   if Sender <> nil then
   begin
      ed_SKParc.Text := '';
   end;
end;

procedure TKatastrPDialog_Form.ed_ParcelaClick(Sender: TObject);
var
   e: TElement;
begin
   e := TElement(ed_Parcela.Items.Objects[ed_Parcela.ItemIndex]);
   ed_Cislo.Text := e.GetPropertyStringByName('PARCIS');
   ed_Podlomeni.Text := e.GetPropertyStringByName('PARPOD');
   ed_SKParc.Text := e.GetPropertyStringByName('Skupar_Cis');
end;

procedure TKatastrPDialog_Form.SetOLHs(const Value: TGis_OLHs);
var
   O: Tgis_OLH;
   i: integer;
   S: string;
begin
  FOLHs := Value;
  S := ed_OLH.Text;
  ed_OLH.Clear;
  if Value <> nil then
  begin
     for i := 0 to Value.LastIndex do
     begin
        O := Tgis_OLH(Value.Elements[i]);
        ed_OLH.Items.Add(O.OLH_ID);
     end;
  end;
  ed_OLH.Text := S;
end;

procedure TKatastrPDialog_Form.SetOnlyPSKManipulate(const Value: boolean);
begin
   FOnlyPSKManipulate := Value;
   if Value then
   begin
      ed_KU.Enabled := false;
      ed_Kategorie.Enabled := false;
      BitBtn1.Enabled := false;
   end;
end;

function TKatastrPDialog_Form.GetDynamicProp(aName: string): string;
var
   i: integer;
begin
   result := '';
   i := SG.Cols[0].IndexOf(aName);
   if i > -1 then
   begin
     result := SG.Cols[1].Strings[i];
   end;
end;

procedure TKatastrPDialog_Form.SetDynamicProp(aName, aValue: string);
var
   i: integer;
begin
   i := SG.Cols[0].IndexOf(aName);
   if i > -1 then
   begin
     SG.Cols[1].Strings[i] := aValue;
   end;
end;

procedure TKatastrPDialog_Form.SetDynamicProps(const Value: TStringList);
begin
   if Value.Count < 1 then
      PanelDynamic.Visible := false
   else
   begin
      SG.RowCount := Value.Count;
      SG.Cols[0].Assign(Value);
   end;
end;

procedure TKatastrPDialog_Form.ed_CisloChange(Sender: TObject);
var
   i: integer;
   cb: boolean;
begin
   i := StrToIntDef(ed_Cislo.Text,0);
   if i = 0 then exit;
   if i < 0 then
      CB := true
   else
      CB := false;
   if cb_Stavebni.Checked <> CB then
      CB_Stavebni.Checked := CB;
   FillParskukn;
end;

procedure TKatastrPDialog_Form.cb_StavebniClick(Sender: TObject);
var
   i: integer;
   s: string;
begin
   s := ed_Cislo.Text;
   i := strToIntDef(s,0);
   if i = 0 then exit;
   i := abs(i);
   if cb_Stavebni.Checked then
      ed_Cislo.Text := IntToStr(-i)
   else
      ed_Cislo.Text := IntToStr(i);
   FillParskukn;
end;

procedure TKatastrPDialog_Form.ed_VlastnikChange(Sender: TObject);
var
   S: string;
   i: integer;
   M: Tgis_Majitel;
begin
   S := ed_Vlastnik.Text;
   //i := StrToIntDef(S,0);
   if (S = '') or (S = '0')  then
   begin
      ed_Vlastnik.Font.Color := clRed;
      l_MajName.Caption := '.....';
   end
   else
   if Majitele <> nil then
   begin
      M := Majitele.GetMajitelCislo(S);
      if M = nil then
      begin
         ed_Vlastnik.Font.Color := clLime;
         l_MajName.Caption := '.....';
      end
      else
      begin
         ed_Vlastnik.Font.Color := clWindowText;
         l_MajName.Caption := M.FullName + ' '+M.Adresa;
      end;
   end;
end;

procedure TKatastrPDialog_Form.SetMajitele(const Value: Tgis_Majitele);
var
   M: Tgis_Majitel;
   i: integer;
   S: string;
begin
  FMajitele := Value;
  S := ed_Vlastnik.Text;
  ed_Vlastnik.Clear;
  if Value <> nil then
  begin
     for i := 0 to Value.LastIndex do
     begin
        M := Tgis_Majitel(Value.Elements[i]);
        ed_Vlastnik.Items.Add(M.Cislo);
     end;
  end;
  ed_Vlastnik.Text := S;
end;

procedure TKatastrPDialog_Form.FillParskukn;
var
   i: integer;
   pomi: integer;
begin
   pomi := StrToIntDef(ed_Cislo.Text,0);
   i := 0;
   if pomi < 0 then
      i := 1
   else
      i := 2;

   if cb_GP.Checked then
      i := i + 5
   else
   begin
      pomi := StrToIntDef(ed_PKCis.Text,0);
      if pomi > 0 then
         i := i + 3;
   end;
   if cb_NEP.Checked then i := 3;
   {$IFDEF UHUL}
       pomi := StrToIntDef(ed_KATUZE_KOD_PUV.Text,0);
       if pomi > 0 then
          i := 9;
   {$ENDIF}
   l_PARSKUKN.Caption := IntToStr(i);
end;

procedure TKatastrPDialog_Form.cb_GPClick(Sender: TObject);
begin
   FillParskukn;
end;

procedure TKatastrPDialog_Form.cb_NEPClick(Sender: TObject);
begin
  FillParskukn;
end;

procedure TKatastrPDialog_Form.ed_KATUZE_KOD_PUVChange(Sender: TObject);
begin
   {$IFDEF UHUL}
   FillParskukn;
   {$ENDIF}
end;

end.
