unit t_LHCProjectManager;

interface
uses
   f_LHCProjectManager,
   t_OrbisDialog;

type

TLHCProjectManager = class(TOrbisDialog)
private
   function GetForm: TLHCProjectManager_Form;
public
   procedure CreateForm; override;
   property  Form: TLHCProjectManager_Form read GetForm;
end;

implementation
uses
   Forms,
   e_Class;

{ TLHCProjectManager }

procedure TLHCProjectManager.CreateForm;
begin
   aForm := TLHCProjectManager_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

function TLHCProjectManager.GetForm: TLHCProjectManager_Form;
begin
   result := TLHCProjectManager_Form(aForm);
end;

INITIALIZATION
   RegisterOrbisClass(TLHCProjectManager);
END.
