{ D-}

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXX                                                             XXX}
{XXX    Copyright (c) - Help Service - Mapping, s.r.o.  1994     XXX}
{XXX                                                             XXX}
{XXX    Pouziti : - DosTopoL                                     XXX}
{XXX              - WinTopoL                                     XXX}
{XXX                                                             XXX}
{XXX                                                             XXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}


{$N+,E+}
unit TrRasObd;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

{$IFDEF Windows}
uses
     StrProc, TranType, PakTrans, Header, MyStream, FuncType;
{$ELSE}
uses dos,
     TranType, PakTrans, Header, MyStream,
     Procenta,
     RastObj;
{$ENDIF}


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


procedure TransformujRastr2J(
{$IFDEF Windows}
                                 DalsiKrokAbortNMCallBackPr,
                                 BylUserAbortAbortNMCallBackPr,
                                 KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                 TransfPtr             : PTransformace;
                                 IY, IX                : longInt;
{$IFDEF Windows}
                             const JmenoNovehoSouboru  : TPathStr;
{$ELSE}
                             const JmenoNovehoSouboru  : PathStr;
{$ENDIF}
                                 fSt                   : PPRStreamRas;
                                 Head                  : TypHeader;
                                 MinYn, MinXn, cyN, cxN: extended;
                                 iyN, ixN              : longInt;
                             var EscDone               : boolean
{$IFNDEF Windows}
                                                                 ;
                                 Procenta                 : TProcentaPtr
{$ENDIF}
                                                                        );
{$IFDEF Windows}
export;
{$ENDIF}

procedure TransformujRastr256J(
{$IFDEF Windows}
                                   DalsiKrokAbortNMCallBackPr,
                                   BylUserAbortAbortNMCallBackPr,
                                   KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                   TransfPtr             : PTransformace;
                                   IY, IX                : longInt;
{$IFDEF Windows}
                             const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                             const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                                   fSt                   : PPRStreamRas;
                                   Head                  : TypHeader;
                                   MinYn, MinXn, cyN, cxN: extended;
                                   iyN, ixN              : longInt;
                               var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                                Procenta                 : TProcentaPtr
{$ENDIF}
                                                                         );
{$IFDEF Windows}
export;
{$ENDIF}

function ZkouskaAfin256TrueJ(
                             TransfPtr             : PTransformace;
                             IY, IX                : longInt;
                             MinYn, MinXn, cyN, cxN: extended;
                             iyN, ixN              : longInt;
                             a1, a2, a3, b1, b2,
                             b3, a1_1              : extended) : boolean;
{$IFDEF Windows}
export;
{$ENDIF}


function ZkouskaAfin256FalseJ(
                              TransfPtr             : PTransformace;
                              IY, IX                : longInt;
                              MinYn, MinXn, cyN, cxN: extended;
                              iyN, ixN              : longInt;
                              a1, a2, a3, b1, b2,
                              b3, a1_1              : extended) : boolean;
{$IFDEF Windows}
export;
{$ENDIF}

function ZkouskaAfin2TrueJ(
                           TransfPtr             : PTransformace;
                           IY, IX                : longInt;
                           MinYn, MinXn, cyN, cxN: extended;
                           iyN, ixN              : longInt;
                           a1, a2, a3, b1, b2,
                           b3, a1_1              : extended) : boolean;
{$IFDEF Windows}
export;
{$ENDIF}

function ZkouskaAfin2FalseJ(
                            TransfPtr             : PTransformace;
                            IY, IX                : longInt;
                            MinYn, MinXn, cyN, cxN: extended;
                            iyN, ixN              : longInt;
                            a1, a2, a3, b1, b2,
                            b3, a1_1              : extended) : boolean;
{$IFDEF Windows}
export;
{$ENDIF}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

{$IFDEF Windows}
uses WinDos, WinProcs, Strings,
     PTranPoV, PTranPoR, MatProc, FilProc, KeyProc,
     RasGlob;
{$ELSE}
uses crt,
     TxSouhl, TxHlasky, TxVyber,
     PTranPoV, PTranPoR, StrProc, MatProc, FilProc, KeyProc,
     Hlasky, Dialog,
     RasGlob;
{$ENDIF}



{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



procedure urci(
               var ObrazS;
               var ObrazN;
                   k,j   : integer); assembler;
asm
        PUSH DS
        LDS SI,OBRAZS
        MOV DX,K
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        TEST DS:[SI],BL
        JNZ @@1
        LDS SI,OBRAZN
        MOV DX,J
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        not bl
        AND BYTE PTR DS:[SI],BL
@@1:    POP DS

end;



procedure WindowLine(
                     var ObrazSt;
                     var ObrazNo;
                         PocatekSt, PocatekNo, Pocet: word) ; assembler;
asm
        PUSH DS
        LDS SI,OBRAZST
        CLD
        MOV DX,PocatekSt
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        MOV AH,BL
        LES DI,OBRAZNO
        MOV DX,PocatekNo
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD DI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BH,128
        SHR BH,CL
        MOV CX,Pocet
        LODSB
@@2:    TEST AL,AH
        JNZ @@1
        MOV BL,BH
        NOT BL
        AND  BYTE PTR ES:[DI],BL
@@1:    SHR BH,1
        JNZ  @@4
        MOV BH,128
        INC DI
@@4:    SHR AH,1
        JNZ  @@3
        LODSB
        MOV AH,128
@@3:    LOOP @@2
        POP DS

END;



function UrciNatoceni(
                      TransfPtr        : PTransformace;
                      MinYn, MinXn, cyN: extended;
                      iyN              : longInt): boolean;
var
  BodZdr, BodCil, BodPomCil: TranType.Bod;

begin
  with TransfPtr^ do
  begin
    BodZdr.X  := MinYn;
    BodZdr.Y  := MinXn;
    InvTransformuj(BodZdr, BodPomCil);

    BodZdr.X  := MinYn + iyN * cyN;
    InvTransformuj(BodZdr, BodCil);

    if BodCil.Y > BodPomCil.Y then
      UrciNatoceni := false
    else
      UrciNatoceni := true;
  end;
end;

function ZkouskaAfin256TrueJ(
                             TransfPtr             : PTransformace;
                             IY, IX                : longInt;
                             MinYn, MinXn, cyN, cxN: extended;
                             iyN, ixN              : longInt;
                             a1, a2, a3, b1, b2,
                             b3, a1_1              : extended) : boolean;
label
  4, 5;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  kSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinYn + iyN * cyN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X - cyN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3     := PomBodZdr.Y*a2/a1_1;

    j := 0;
    repeat
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
      if sl <> l then
      begin
        if (l > 0) and (l <= ix) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      kSt         := round(BodCil.X);

      if b1 < 0 then
        p := trunc(iyN - ((l - bpom3)/(b1*cyN) + bpom1))
      else
        p := pred(iyN);

      if a1_1 > 0 then
        q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := pred(iyN - j);

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > iyN - j then
        r := iyN - j;

      k_r := k+r;

      if (k >= 0) and (k < iy) and (k_r <= iy) then
      begin
        if Zapisovat then;
      end
      else
        if k < 0 then
        begin
          if k_r >= 0 then
          begin
            inc(j, -k);
            inc(r,  k);
            if r >= iy then
            begin
              if Zapisovat then;
              goto 5;
            end else
            begin
              BodCil.X := BodCil.X - k*dyC;
              BodCil.Y := BodCil.Y - k*dxC;
              BodZdr.X := BodZdr.X + k*cyN;
              if Zapisovat and (r > 0)  then;
            end;
          end;
        end else
        begin
          if k < iy then
            if Zapisovat then;
          goto 5;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X - r*cyN;
    until j >= pred(iyN);

  5:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinYn + iyN * cyN;
    InvTransformuj(BodZdr, BodCil);

    BodZdr.X := BodZdr.X - cyN;
    InvTransformuj(BodZdr, PomBodCil);

    dxC := PomBodCil.Y - BodCil.Y;
    dyC := PomBodCil.X - BodCil.X;

    j := -1;
    repeat
      inc(j);;
      if j = iyN then goto 4;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
    until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
    sp := j;

    if sl <> l then
    begin
      sl := l;
    end;

    for j := succ(sp) to pred(iyN) do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k  := round(iy-BodCil.X);
      l  := round(BodCil.Y);
      if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
        goto 4
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;
  4:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
  if Doba1 < Doba2 then
    ZkouskaAfin256TrueJ := true
  else
    ZkouskaAfin256TrueJ := false;
end;


function ZkouskaAfin256FalseJ(
                              TransfPtr             : PTransformace;
                              IY, IX                : longInt;
                              MinYn, MinXn, cyN, cxN: extended;
                              iyN, ixN              : longInt;
                              a1, a2, a3, b1, b2,
                              b3, a1_1              : extended) : boolean;
label
  3, 6;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  kSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinYn - cyN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X + cyN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    PomBodZdr.Y := BodZdr.Y - CilStred.Y;
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3       := PomBodZdr.Y*a2/a1_1;

    j := 1;
    repeat
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
      if sl <> l then
      begin
        if (l > 0) and (l <= ix) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      kSt         := round(BodCil.X);

      if b1 > 0 then
        p := trunc((l - bpom3)/(b1*cyN) + bpom1)
      else
        p := iyN;

      if a1_1 > 0 then
        q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := iyN - j;

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > succ(iyN - j) then
        r := succ(iyN - j);

      k_r := k-r;

      if (k >= 0) and (k < iy) and (k_r >= -1) then
      begin
        if Zapisovat then;
      end
      else
        if k >= iy then
        begin
          if succ(k_r) < iy then
          begin
            if pred(iy) - k_r < iy then
            begin
              if Zapisovat and (r > 0)  then;
            end else
            begin
              if Zapisovat then;
              goto 6;
            end;
          end;
        end else
        begin
          if k >= 0 then
            if Zapisovat then;
          goto 6;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X + r*cyN;
    until j >= iyN;

  6:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinYn - cyN;
    InvTransformuj(BodZdr, BodCil);

    BodZdr.X := BodZdr.X + cyN;
    InvTransformuj(BodZdr, PomBodCil);

    dxc := PomBodCil.Y - BodCil.Y;
    dyc := PomBodCil.X - BodCil.X;

    j := iyN;
    repeat
      dec(j);
      if j = -1 then goto 3;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
    until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
    sp := j;

    if sl <> l then
    begin
      sl := l;
    end;

    for j := pred(sp) downto 0 do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k  := round(iy-BodCil.X);
      l  := round(BodCil.Y);
      if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
        goto 3
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;

  3:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
  if Doba1 < Doba2 then
    ZkouskaAfin256FalseJ := true
  else
    ZkouskaAfin256FalseJ := false;
end;




function ZkouskaAfin2TrueJ(
                           TransfPtr             : PTransformace;
                           IY, IX                : longInt;
                           MinYn, MinXn, cyN, cxN: extended;
                           iyN, ixN              : longInt;
                           a1, a2, a3, b1, b2,
                           b3, a1_1              : extended) : boolean;
label
  4, 5;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  kSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinYn + iyN * cyN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X - cyN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3     := PomBodZdr.Y*a2/a1_1;

    j := 0;
    repeat
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
      if sl <> l then
      begin
        if (l > 0) and (l <= ix) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      kSt         := round(BodCil.X);

      if b1 < 0 then
        p := trunc(iyN - ((l - bpom3)/(b1*cyN) + bpom1))
      else
        p := pred(iyN);

      if a1_1 > 0 then
        q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := pred(iyN - j);

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > iyN - j then
        r := iyN - j;

      k_r := k+r;

      if (k >= 0) and (k < iy) and (k_r <= iy) then
      begin
        if Zapisovat then;
      end
      else
        if k < 0 then
        begin
          if k_r >= 0 then
          begin
            inc(j, -k);
            inc(r,  k);
            if r >= iy then
            begin
              if Zapisovat then;
              goto 5;
            end else
            begin
              BodCil.X := BodCil.X - k*dyC;
              BodCil.Y := BodCil.Y - k*dxC;
              BodZdr.X := BodZdr.X + k*cyN;
              if Zapisovat and (r > 0)  then;
            end;
          end;
        end else
        begin
          if k < iy then
            if Zapisovat then;
          goto 5;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X - r*cyN;
    until j >= pred(iyN);

  5:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinYn + iyN * cyN;
    InvTransformuj(BodZdr, BodCil);

    BodZdr.X := BodZdr.X - cyN;
    InvTransformuj(BodZdr, PomBodCil);

    dxC := PomBodCil.Y - BodCil.Y;
    dyC := PomBodCil.X - BodCil.X;

    j := -1;
    repeat
      inc(j);;
      if j = iyN then goto 4;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
    until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
    sp := j;

    if sl <> l then
    begin
      sl := l;
    end;

    for j := succ(sp) to pred(iyN) do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k  := round(iy-BodCil.X);
      l  := round(BodCil.Y);
      if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
        goto 4
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;
  4:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
  if Doba1 < Doba2 then
    ZkouskaAfin2TrueJ := true
  else
    ZkouskaAfin2TrueJ := false;
end;


function ZkouskaAfin2FalseJ(
                            TransfPtr             : PTransformace;
                            IY, IX                : longInt;
                            MinYn, MinXn, cyN, cxN: extended;
                            iyN, ixN              : longInt;
                            a1, a2, a3, b1, b2,
                            b3, a1_1              : extended) : boolean;
label
  3, 6;

const
  Den = 8640000;

var
  h1, m1, s1, hund1,
  h2, m2, s2, hund2,
  h3, m3, s3, hund3 : Word;
  Doba1, Doba2, Time1, Time2, Time3: longInt;
  kSt, s, sp, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;

begin
  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn;

    if b1 <> 0 then
      bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
    if a1_1 <> 0 then
    begin
      apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
      apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
    end;

    GetTime(h1, m1, s1, hund1);

    sl := -2147483640;

    BodZdr.X := MinYn - cyN;
    InvTransformuj(BodZdr, PomBodCil);

    BodZdr.X := BodZdr.X + cyN;
    InvTransformuj(BodZdr, BodCil);

    dxC := BodCil.Y - PomBodCil.Y;
    dyC := BodCil.X - PomBodCil.X;

    PomBodZdr.Y := BodZdr.Y - CilStred.Y;
    bpom3       := PomBodZdr.Y*b2;
    if a1_1 <> 0 then
      apom3       := PomBodZdr.Y*a2/a1_1;

    j := 1;
    repeat
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
      if sl <> l then
      begin
        if (l > 0) and (l <= ix) then
          Zapisovat := true
        else
          Zapisovat := false;
        sl := l;
      end;

      PomBodZdr.X := BodZdr.X - CilStred.X;
      kSt         := round(BodCil.X);

      if b1 > 0 then
        p := trunc((l - bpom3)/(b1*cyN) + bpom1)
      else
        p := iyN;

      if a1_1 > 0 then
        q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
      else
        if a1_1 < 0 then
          q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
        else
          q := iyN - j;

      if p-j < q then
        r := succ(p-j)
      else
        r := succ(q);

      if r < 1 then
        r := 1;

      if r > succ(iyN - j) then
        r := succ(iyN - j);

      k_r := k-r;

      if (k >= 0) and (k < iy) and (k_r >= -1) then
      begin
        if Zapisovat then;
      end
      else
        if k >= iy then
        begin
          if succ(k_r) < iy then
          begin
            if pred(iy) - k_r < iy then
            begin
              if Zapisovat and (r > 0)  then;
            end else
            begin
              if Zapisovat then;
              goto 6;
            end;
          end;
        end else
        begin
          if k >= 0 then
            if Zapisovat then;
          goto 6;
        end;

      inc(j, r);
      BodCil.X := BodCil.X + r*dyC;
      BodCil.Y := BodCil.Y + r*dxC;
      BodZdr.X := BodZdr.X + r*cyN;
    until j >= iyN;

  6:GetTime(h2, m2, s2, hund2);

    sl := -2147483640;

    BodZdr.X := MinYn - cyN;
    InvTransformuj(BodZdr, BodCil);

    BodZdr.X := BodZdr.X + cyN;
    InvTransformuj(BodZdr, PomBodCil);

    dxc := PomBodCil.Y - BodCil.Y;
    dyc := PomBodCil.X - BodCil.X;

    j := iyN;
    repeat
      dec(j);
      if j = -1 then goto 3;
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k := round(iy-BodCil.X);
      l := round(BodCil.Y);
    until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
    sp := j;

    if sl <> l then
    begin
      sl := l;
    end;

    for j := pred(sp) downto 0 do
    begin
      BodCil.X := BodCil.X + dyC;
      BodCil.Y := BodCil.Y + dxC;
      k  := round(iy-BodCil.X);
      l  := round(BodCil.Y);
      if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
        goto 3
      else
      begin
        if sl <> l then
        begin
          sl := l;
        end;
      end;
    end;

  3:GetTime(h3, m3, s3, hund3);

  end;
  Time1 := longInt(h1)*3600*100 + longInt(m1)*60*100 + s1*100 + hund1;
  Time2 := longInt(h2)*3600*100 + longInt(m2)*60*100 + s2*100 + hund2;
  Time3 := longInt(h3)*3600*100 + longInt(m3)*60*100 + s3*100 + hund3;
  Doba1 := Time2 - Time1;
  Doba2 := Time3 - Time2;
  if Doba1 < 0 then
    Doba1 := Den+Doba1;
  if Doba2 < 0 then
    Doba2 := Den+Doba2;
  if Doba1 < Doba2 then
    ZkouskaAfin2FalseJ := true
  else
    ZkouskaAfin2FalseJ := false;
end;










procedure Afin256TrueJ(
{$IFDEF Windows}
                           DalsiKrokAbortNMCallBackPr,
                           BylUserAbortAbortNMCallBackPr,
                           KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                           TransfPtr             : PTransformace;
                           IY, IX                : longInt;
{$IFDEF Windows}
                     const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                     const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                           fSt                   : PPRStreamRas;
                           fN                    : PPWStream;
                           MinYn, MinXn, cyN, cxN: extended;
                           iyN, ixN              : longInt;
                       var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                        Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );
label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  kSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  1-a1*cyN;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := 1-a1*cyN;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin256TrueJ(TransfPtr, IY, IX, MinYn, MinXn, cyN, cxN,
                           iyN, ixN,
                           a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MinXn - cxN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, iyN, 0)
        else
          FillChar(ObrazN^, iyN, 255);

        BodZdr.X := MinYn + iyN * cyN;
        BodZdr.Y := BodZdr.Y + cxN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X - cyN;
        InvTransformuj(BodZdr, BodCil);

        dxC := BodCil.Y - PomBodCil.Y;
        dyC := BodCil.X - PomBodCil.X;

        PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3     := PomBodZdr.Y*a2/a1_1;

        j := 0;
        repeat
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
          if sl <> l then
          begin
            if (l > 0) and (l <= ix) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS, pred(l));
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          kSt         := round(BodCil.X);

          if b1 < 0 then
            p := trunc(iyN - ((l - bpom3)/(b1*cyN) + bpom1))
          else
            p := pred(iyN);

          if a1_1 > 0 then
            q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := pred(iyN - j);

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > iyN - j then
            r := iyN - j;

          k_r := k+r;

          if (k >= 0) and (k < iy) and (k_r <= iy) then
          begin
            if Zapisovat then
              move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], r);
          end
          else
            if k < 0 then
            begin
              if k_r >= 0 then
              begin
                inc(j, -k);
                inc(r,  k);
                if r >= iy then
                begin
                  if Zapisovat then
                    move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], iy);
                  goto 1;
                end else
                begin
                  BodCil.X := BodCil.X - k*dyC;
                  BodCil.Y := BodCil.Y - k*dxC;
                  BodZdr.X := BodZdr.X + k*cyN;
                  if Zapisovat and (r > 0)  then
                    move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], r);
                end;
              end;
            end else
            begin
              if k < iy then
                if Zapisovat then
                  move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], succ(iy - k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X - r*cyN;
        until j >= pred(iyN);

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MinXn - cxN;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, iyN, 0)
        else
          FillChar(ObrazN^, iyN, 255);

        BodZdr.X := MinYn + iyN * cyN;
        BodZdr.Y := BodZdr.Y + cxN;
        InvTransformuj(BodZdr, BodCil);

        BodZdr.X := BodZdr.X - cyN;
        InvTransformuj(BodZdr, PomBodCil);

        dxC := PomBodCil.Y - BodCil.Y;
        dyC := PomBodCil.X - BodCil.X;

        j := -1;
        repeat
          inc(j);;
          if j = iyN then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
        until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
        sp := j;

        if sl <> l then
        begin
          fSt^.Read(ObrazS, pred(l));
          sl := l;
        end;
        PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

        for j := succ(sp) to pred(iyN) do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k  := round(iy-BodCil.X);
          l  := round(BodCil.Y);
          if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, pred(l));
              sl := l;
            end;
            PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;


procedure Afin256FalseJ(
{$IFDEF Windows}
                            DalsiKrokAbortNMCallBackPr,
                            BylUserAbortAbortNMCallBackPr,
                            KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                            TransfPtr             : PTransformace;
                            IY, IX                : longInt;
{$IFDEF Windows}
                      const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                      const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                            fSt                   : PPRStreamRas;
                            fN                    : PPWStream;
                            MinYn, MinXn, cyN, cxN: extended;
                            iyN, ixN              : longInt;
                        var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                         Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  kSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  a1*cyN-1;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := a1*cyN-1;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin256FalseJ(TransfPtr, IY, IX, MinYn, MinXn, cyN, cxN,
                            iyN, ixN,
                            a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MinXn - cxN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, iyN, 0)
        else
          FillChar(ObrazN^, iyN, 255);

        BodZdr.X := MinYn - cyN;
        BodZdr.Y := BodZdr.Y + cxN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, BodCil);

        dxC := BodCil.Y - PomBodCil.Y;
        dyC := BodCil.X - PomBodCil.X;

        PomBodZdr.Y := BodZdr.Y - CilStred.Y;
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3       := PomBodZdr.Y*a2/a1_1;

        j := 1;
        repeat
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
          if sl <> l then
          begin
            if (l > 0) and (l <= ix) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS, pred(l));
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          kSt         := round(BodCil.X);

          if b1 > 0 then
            p := trunc((l - bpom3)/(b1*cyN) + bpom1)
          else
            p := iyN;

          if a1_1 > 0 then
            q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := iyN - j;

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > succ(iyN - j) then
            r := succ(iyN - j);

          k_r := k-r;

          if (k >= 0) and (k < iy) and (k_r >= -1) then
          begin
            if Zapisovat then
              move(PBuffer0(ObrazS)^[succ(k_r)], PBuffer0(ObrazN)^[succ(iyN-j-r)], r);
          end
          else
            if k >= iy then
            begin
              if succ(k_r) < iy then
              begin
                if pred(iy) - k_r < iy then
                begin
                  if Zapisovat and (r > 0)  then
                    move(PBuffer0(ObrazS)^[succ(k_r)], PBuffer0(ObrazN)^[iyN-j-r], pred(iy) - k_r);
                end else
                begin
                  if Zapisovat then
                    move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[iyN-j-iy], iy);
                  goto 1;
                end;
              end;
            end else
            begin
              if k >= 0 then
                if Zapisovat then
                  move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[succ(iyN-j-succ(k))], succ(k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X + r*cyN;
        until j >= iyN;

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MinXn - cxN;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        if fN^.Bits4 then
          FillChar(ObrazN^, iyN, 0)
        else
          FillChar(ObrazN^, iyN, 255);

        BodZdr.Y := BodZdr.Y + cxN;
        BodZdr.X := MinYn - cyN;
        InvTransformuj(BodZdr, BodCil);

        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, PomBodCil);

        dxc := PomBodCil.Y - BodCil.Y;
        dyc := PomBodCil.X - BodCil.X;

        j := iyN;
        repeat
          dec(j);
          if j = -1 then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
        until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
        sp := j;

        if sl <> l then
        begin
          fSt^.Read(ObrazS, pred(l));
          sl := l;
        end;
        PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

        for j := pred(sp) downto 0 do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k  := round(iy-BodCil.X);
          l  := round(BodCil.Y);
          if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, pred(l));
              sl := l;
            end;
            PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;



procedure Ost256TrueJ(
{$IFDEF Windows}
                          DalsiKrokAbortNMCallBackPr,
                          BylUserAbortAbortNMCallBackPr,
                          KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                          TransfPtr             : PTransformace;
                          IY, IX                : longInt;
{$IFDEF Windows}
                    const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                    const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                          fSt                   : PPRStreamRas;
                          fN                    : PPWStream;
                          MinYn, MinXn, cyN, cxN: extended;
                          iyN, ixN              : longInt;
                      var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                          Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn - cxN;
    for i := 1 to ixN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      if fN^.Bits4 then
        FillChar(ObrazN^, iyN, 0)
      else
        FillChar(ObrazN^, iyN, 255);

      BodZdr.Y := BodZdr.Y + cxN;
      BodZdr.X := MinYn + iyN * cyN;

      j := -1;
      repeat
        inc(j);
        if j = iyN then goto 1;
        BodZdr.X := BodZdr.X - cyN;
        InvTransformuj(BodZdr, BodCil);
        k := round(iy-BodCil.X);
        l := round(BodCil.Y);
      until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
      sp := j;

      if sl <> l then
      begin
        fSt^.Read(ObrazS, pred(l));
        sl := l;
      end;
      PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

      for j := succ(sp) to pred(iyN) do
      begin
        BodZdr.X := BodZdr.X - cyN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k  := round(iy-BodCil.X);
        l  := round(BodCil.Y);

        if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
          goto 1
        else
        begin
          if sl <> l then
          begin
            fSt^.Read(ObrazS, pred(l));
            sl := l;
          end;
          PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;




procedure Ost256FalseJ(
{$IFDEF Windows}
                           DalsiKrokAbortNMCallBackPr,
                           BylUserAbortAbortNMCallBackPr,
                           KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                           TransfPtr             : PTransformace;
                           IY, IX                : longInt;
{$IFDEF Windows}
                     const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                     const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                           fSt                   : PPRStreamRas;
                           fN                    : PPWStream;
                           MinYn, MinXn, cyN, cxN: extended;
                           iyN, ixN              : longInt;
                       var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                           Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );
label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn - cxN;

    for i := 1 to ixN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      if fN^.Bits4 then
        FillChar(ObrazN^, iyN, 0)
      else
        FillChar(ObrazN^, iyN, 255);

      BodZdr.Y := BodZdr.Y + cxN;
      BodZdr.X := MinYn - cyN;

      j := iyN;
      repeat
        dec(j);
        if j = -1 then goto 1;
        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, BodCil);
        k := round(iy-BodCil.X);
        l := round(BodCil.Y);
      until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
      sp := j;

      if sl <> l then
      begin
        fSt^.Read(ObrazS, pred(l));
        sl := l;
      end;
      PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];

      for j := pred(sp) downto 0 do
      begin
        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, BodCil);
        k := round(iy-BodCil.X);
        l := round(BodCil.Y);
        if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
          goto 1
        else
        begin
          if sl <> l then
          begin
            fSt^.Read(ObrazS, pred(l));
            sl := l;
          end;
          PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;



procedure Afin2TrueJ(
{$IFDEF Windows}
                         DalsiKrokAbortNMCallBackPr,
                         BylUserAbortAbortNMCallBackPr,
                         KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                         TransfPtr             : PTransformace;
                         IY, IX                : longInt;
{$IFDEF Windows}
                   const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                   const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                         fSt                   : PPRStreamRas;
                         fN                    : PPWStream;
                         MinYn, MinXn, cyN, cxN: extended;
                         iyN, ixN              : longInt;
                     var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                         Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, kSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  PocetBytu := iyN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  1-a1*cyN;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := 1-a1*cyN;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin2TrueJ(TransfPtr, IY, IX, MinYn, MinXn, cyN, cxN,
                         iyN, ixN,
                         a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MinXn - cxN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillchar(ObrazN^, PocetBytu, 255);

        BodZdr.X := MinYn + iyN * cyN;
        BodZdr.Y := BodZdr.Y + cxN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X - cyN;
        InvTransformuj(BodZdr, BodCil);

        dxC := BodCil.Y - PomBodCil.Y;
        dyC := BodCil.X - PomBodCil.X;

        PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3     := PomBodZdr.Y*a2/a1_1;

        j := 0;
        repeat
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
          if sl <> l then
          begin
            if (l > 0) and (l <= ix) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS, pred(l));
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          kSt         := round(BodCil.X);

          if b1 < 0 then
            p := trunc(iyN - ((l - bpom3)/(b1*cyN) + bpom1))
          else
            p := pred(iyN);

          if a1_1 > 0 then
            q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := pred(iyN - j);

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > iyN - j then
            r := iyN - j;

          k_r := k+r;

          if (k >= 0) and (k < iy) and (k_r <= iy) then
          begin
            if Zapisovat then
              WindowLine(ObrazS^, ObrazN^, k, j, r);
          end
          else
            if k < 0 then
            begin
              if k_r >= 0 then
              begin
                inc(j, -k);
                inc(r,  k);
                if r >= iy then
                begin
                  if Zapisovat then
                    WindowLine(ObrazS^, ObrazN^, 0, j, iy);
                  goto 1;
                end else
                begin
                  BodCil.X := BodCil.X - k*dyC;
                  BodCil.Y := BodCil.Y - k*dxC;
                  BodZdr.X := BodZdr.X + k*cyN;
                  if Zapisovat and (r > 0)  then
                    WindowLine(ObrazS^, ObrazN^, 0, j, r);
                end;
              end;
            end else
            begin
              if k < iy then
                if Zapisovat then
                  WindowLine(ObrazS^, ObrazN^, k, j, succ(iy-k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X - r*cyN;
        until j >= pred(iyN);

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MinXn - cxN;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillChar(ObrazN^, PocetBytu, 255);

        BodZdr.X := MinYn + iyN * cyN;
        BodZdr.Y := BodZdr.Y + cxN;
        InvTransformuj(BodZdr, BodCil);

        BodZdr.X := BodZdr.X - cyN;
        InvTransformuj(BodZdr, PomBodCil);

        dxC := PomBodCil.Y - BodCil.Y;
        dyC := PomBodCil.X - BodCil.X;

        j := -1;
        repeat
          inc(j);;
          if j = iyN then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
        until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
        sp := j;

        if sl <> l then
        begin
          fSt^.Read(ObrazS, pred(l));
          sl := l;
        end;
        urci(ObrazS^, ObrazN^, k, j);

        for j := succ(sp) to pred(iyN) do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k  := round(iy-BodCil.X);
          l  := round(BodCil.Y);
          if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, pred(l));
              sl := l;
            end;
            urci(ObrazS^, ObrazN^, k, j);
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;


procedure Afin2FalseJ(
{$IFDEF Windows}
                          DalsiKrokAbortNMCallBackPr,
                          BylUserAbortAbortNMCallBackPr,
                          KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                          TransfPtr             : PTransformace;
                          IY, IX                : longInt;
{$IFDEF Windows}
                    const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                    const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                          fSt                   : PPRStreamRas;
                          fN                    : PPWStream;
                          MinYn, MinXn, cyN, cxN: extended;
                          iyN, ixN              : longInt;
                      var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                          Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

label
  1, 2;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, kSt, sp, i, j, p, q, r, k, l, sl, k_r: longint;
  BodCil, PomBodCil, BodZdr, PomBodZdr: TranType.Bod;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  Zapisovat: boolean;
{$IFDEF Windows}
  Retezec1: array[0..255] of char;
{$ENDIF}

begin
  PocetBytu := iyN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
{$IFDEF Windows}
    LoadString(HInstance, 621, Retezec1, 256);
    if (StrIComp(TransfPtr^.NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) then
{$ELSE}
    if NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'} then
{$ENDIF}
    begin
      a1   :=  InvKlic[1];
      a2   := -InvKlic[2];
      a3   :=  0;
      b1   :=  InvKlic[2];
      b2   :=  InvKlic[1];
      b3   :=  0;
      a1_1 :=  a1*cyN-1;
    end else
    begin
      a1   := InvKlic[1];
      a2   := InvKlic[2];
      a3   := InvKlic[3];
      b1   := InvKlic[4];
      b2   := InvKlic[5];
      b3   := InvKlic[6];
      a1_1 := a1*cyN-1;
    end;

    if abs(b1)   < eps then b1   := 0;
    if abs(a1_1) < eps then a1_1 := 0;

    if ZkouskaAfin2FalseJ(TransfPtr, IY, IX, MinYn, MinXn, cyN, cxN,
                         iyN, ixN,
                         a1, a2, a3, b1, b2, b3, a1_1) then
    begin
      BodZdr.Y := MinXn - cxN;

      if b1 <> 0 then
        bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + cyN + CilStred.X - MinYn)/cyN;
      if a1_1 <> 0 then
      begin
        apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
        apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
      end;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillChar(ObrazN^, PocetBytu, 255);

        BodZdr.X := MinYn - cyN;
        BodZdr.Y := BodZdr.Y + cxN;
        InvTransformuj(BodZdr, PomBodCil);

        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, BodCil);

        dxC := BodCil.Y - PomBodCil.Y;
        dyC := BodCil.X - PomBodCil.X;

        PomBodZdr.Y := BodZdr.Y - CilStred.Y;
        bpom3       := PomBodZdr.Y*b2;
        if a1_1 <> 0 then
          apom3       := PomBodZdr.Y*a2/a1_1;

        j := 1;
        repeat
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
          if sl <> l then
          begin
            if (l > 0) and (l <= ix) then
            begin
              Zapisovat := true;
              fSt^.Read(ObrazS, pred(l));
            end
            else
              Zapisovat := false;
            sl := l;
          end;

          PomBodZdr.X := BodZdr.X - CilStred.X;
          kSt         := round(BodCil.X);

          if b1 > 0 then
            p := trunc((l - bpom3)/(b1*cyN) + bpom1)
          else
            p := iyN;

          if a1_1 > 0 then
            q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
          else
            if a1_1 < 0 then
              q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
            else
              q := iyN - j;

          if p-j < q then
            r := succ(p-j)
          else
            r := succ(q);

          if r < 1 then
            r := 1;

          if r > succ(iyN - j) then
            r := succ(iyN - j);

          k_r := k-r;

          if (k >= 0) and (k < iy) and (k_r >= -1) then
          begin
            if Zapisovat then
              WindowLine(ObrazS^, ObrazN^, succ(k_r), succ(iyN-j-r), r);
          end
          else
            if k >= iy then
            begin
              if succ(k_r) < iy then
              begin
                if pred(iy) - k_r < iy then
                begin
                  if Zapisovat and (r > 0)  then
                    WindowLine(ObrazS^, ObrazN^, succ(k_r), iyN-j-r, pred(iy) - k_r);
                end else
                begin
                  if Zapisovat then
                    WindowLine(ObrazS^, ObrazN^, 0, iyN-j-iy, iy);
                  goto 1;
                end;
              end;
            end else
            begin
              if k >= 0 then
                if Zapisovat then
                  WindowLine(ObrazS^, ObrazN^, 0, succ(iyN-j-succ(k)), succ(k));
              goto 1;
            end;

          inc(j, r);
          BodCil.X := BodCil.X + r*dyC;
          BodCil.Y := BodCil.Y + r*dxC;
          BodZdr.X := BodZdr.X + r*cyN;
        until j >= iyN;

{$IFDEF Windows}
      1:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      1:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end else
    begin
      BodZdr.Y := MinXn - cxN;

      for i := 1 to ixN do
      begin
        fN^.NastavRadPtr(ObrazN);
        if fN^.Status <> 0 then
        begin
          Dispose(fN, Done);
          exit;
        end;

        fillChar(ObrazN^, PocetBytu, 255);

        BodZdr.Y := BodZdr.Y + cxN;
        BodZdr.X := MinYn - cyN;
        InvTransformuj(BodZdr, BodCil);

        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, PomBodCil);

        dxc := PomBodCil.Y - BodCil.Y;
        dyc := PomBodCil.X - BodCil.X;

        j := iyN;
        repeat
          dec(j);
          if j = -1 then goto 2;
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k := round(iy-BodCil.X);
          l := round(BodCil.Y);
        until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
        sp := j;

        if sl <> l then
        begin
          fSt^.Read(ObrazS, pred(l));
          sl := l;
        end;
        urci(ObrazS^, ObrazN^, k, j);

        for j := pred(sp) downto 0 do
        begin
          BodCil.X := BodCil.X + dyC;
          BodCil.Y := BodCil.Y + dxC;
          k  := round(iy-BodCil.X);
          l  := round(BodCil.Y);
          if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
            goto 2
          else
          begin
            if sl <> l then
            begin
              fSt^.Read(ObrazS, pred(l));
              sl := l;
            end;
            urci(ObrazS^, ObrazN^, k, j);
          end;
        end;

{$IFDEF Windows}
      2:DalsiKrokAbortNMCallBackPr(0, 0);
        KeepWindowsAliveCallBackPr(0, 0);
        if BylUserAbortAbortNMCallBackPr(0, 0) then
        begin
          Dispose(fN, Done);
(*          ZrusRastr(JmenoNovehoSouboru, false, false);*)
          EscDone := true;
          exit;
        end;
{$ELSE}
      2:if keyPressed then
          if ReadKey = Esc then
            if Souhlas(Sou_SkutecnePrerusitTransf) then
            begin
              Dispose(fN, Done);
              ZrusRastr(JmenoNovehoSouboru);
              EscDone := true;
              exit;
            end;
        if Procenta^.ProvedZmenu then
          Procenta^.Vypis;
{$ENDIF}
      end;
    end;
  end;
  Dispose(fN,Done);
end;


procedure Ost2TrueJ(
{$IFDEF Windows}
                        DalsiKrokAbortNMCallBackPr,
                        BylUserAbortAbortNMCallBackPr,
                        KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                        TransfPtr             : PTransformace;
                        IY, IX                : longInt;
{$IFDEF Windows}
                  const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                  const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                        fSt                   : PPRStreamRas;
                        fN                    : PPWStream;
                        MinYn, MinXn, cyN, cxN: extended;
                        iyN, ixN              : longInt;
                    var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                     Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  PocetBytu := iyN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn - cxN;
    for i := 1 to ixN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      fillChar(ObrazN^, PocetBytu, 255);

      BodZdr.Y := BodZdr.Y + cxN;
      BodZdr.X := MinYn + iyN * cyN;

      j := -1;
      repeat
        inc(j);
        if j = iyN then goto 1;
        BodZdr.X := BodZdr.X - cyN;
        InvTransformuj(BodZdr, BodCil);
        k := round(iy-BodCil.X);
        l := round(BodCil.Y);
      until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
      sp := j;

      if sl <> l then
      begin
        fSt^.Read(ObrazS, pred(l));
        sl := l;
      end;
      urci(ObrazS^, ObrazN^, k, j);

      for j := succ(sp) to pred(iyN) do
      begin
        BodZdr.X := BodZdr.X - cyN;
        TransfPtr^.InvTransformuj(BodZdr, BodCil);
        k  := round(iy-BodCil.X);
        l  := round(BodCil.Y);

        if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
          goto 1
        else
        begin
          if sl <> l then
          begin
            fSt^.Read(ObrazS, pred(l));
            sl := l;
          end;
          urci(ObrazS^, ObrazN^, k, j);
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;




procedure Ost2FalseJ(
{$IFDEF Windows}
                         DalsiKrokAbortNMCallBackPr,
                         BylUserAbortAbortNMCallBackPr,
                         KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                         TransfPtr             : PTransformace;
                         IY, IX                : longInt;
{$IFDEF Windows}
                   const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                   const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                         fSt                   : PPRStreamRas;
                         fN                    : PPWStream;
                         MinYn, MinXn, cyN, cxN: extended;
                         iyN, ixN              : longInt;
                     var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                         Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );
label
  1;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  PocetBytu, sp, i, j, k, l, sl: longint;
  BodCil, BodZdr: TranType.Bod;

begin
  PocetBytu := iyN shr 3;

  sl := -2147483640;

  with TransfPtr^ do
  begin
    BodZdr.Y := MinXn - cxN;

    for i := 1 to ixN do
    begin
      fN^.NastavRadPtr(ObrazN);
      if fN^.Status <> 0 then
      begin
        Dispose(fN, Done);
        exit;
      end;

      fillChar(ObrazN^, PocetBytu, 255);

      BodZdr.Y := BodZdr.Y + cxN;
      BodZdr.X := MinYn - cyN;

      j := iyN;
      repeat
        dec(j);
        if j = -1 then goto 1;
        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, BodCil);
        k := round(iy-BodCil.X);
        l := round(BodCil.Y);
      until (k >= 0) and (k < iy) and (l > 0) and (l <= ix);
      sp := j;

      if sl <> l then
      begin
        fSt^.Read(ObrazS, pred(l));
        sl := l;
      end;
      urci(ObrazS^, ObrazN^, k, j);

      for j := pred(sp) downto 0 do
      begin
        BodZdr.X := BodZdr.X + cyN;
        InvTransformuj(BodZdr, BodCil);
        k := round(iy-BodCil.X);
        l := round(BodCil.Y);
        if (k < 0) or (k >= iy) or (l < 1) or (l > ix) then
          goto 1
        else
        begin
          if sl <> l then
          begin
            fSt^.Read(ObrazS, pred(l));
            sl := l;
          end;
          urci(ObrazS^, ObrazN^, k, j);
        end;
      end;

{$IFDEF Windows}
    1:DalsiKrokAbortNMCallBackPr(0, 0);
      KeepWindowsAliveCallBackPr(0, 0);
      if BylUserAbortAbortNMCallBackPr(0, 0) then
      begin
        Dispose(fN, Done);
(*        ZrusRastr(JmenoNovehoSouboru, false, false);*)
        EscDone := true;
        exit;
      end;
{$ELSE}
    1:if keyPressed then
        if ReadKey = Esc then
          if Souhlas(Sou_SkutecnePrerusitTransf) then
          begin
            Dispose(fN, Done);
            ZrusRastr(JmenoNovehoSouboru);
            EscDone := true;
            exit;
          end;
      if Procenta^.ProvedZmenu then
        Procenta^.Vypis;
{$ENDIF}
    end;
  end;
  Dispose(fN,Done);
end;






procedure TransformujRastr256J(
{$IFDEF Windows}
                                   DalsiKrokAbortNMCallBackPr,
                                   BylUserAbortAbortNMCallBackPr,
                                   KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                   TransfPtr             : PTransformace;
                                   IY, IX                : longInt;
{$IFDEF Windows}
                             const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                             const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                                   fSt                   : PPRStreamRas;
                                   Head                  : TypHeader;
                                   MinYn, MinXn, cyN, cxN: extended;
                                   iyN, ixN              : longInt;
                               var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                                Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );


var
  fN: PPWStream;
{$IFDEF Windows}
  Retezec1, Retezec2: array[0..255] of char;
{$ENDIF}

begin
  EscDone := false;

  if fSt^.Bits4 then
    fN := New(PPWStream,Init(JmenoNovehoSouboru, 3, iyN shr 1, TopolHeaderSize, 65000))
  else
    fN := New(PPWStream,Init(JmenoNovehoSouboru, 1, iyN, TopolHeaderSize, 65000));

  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  with Head do
  begin
    xRasMin := MinXn;
    yRasMin := MinYn;
    xRasMax := MinXn + pred(ixN) * cxN;
    yRasMax := MinYn + pred(iyN) * cyN;
    Rows    := ixN;
    Cols    := iyN;
    Zoom    := 0;
  end;

  fN^.PisHeader(Head);
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  if UrciNatoceni(TransfPtr, MinYn, MinXn, cyN, iyN) then
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin256TrueJ(
{$IFDEF Windows}
                     DalsiKrokAbortNMCallBackPr,
                     BylUserAbortAbortNMCallBackPr,
                     KeepWindowsAliveCallBackPr,
{$ENDIF}
                     TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                     MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost256TrueJ(
{$IFDEF Windows}
                     DalsiKrokAbortNMCallBackPr,
                     BylUserAbortAbortNMCallBackPr,
                     KeepWindowsAliveCallBackPr,
{$ENDIF}
                    TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                    MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
    end
  else
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin256FalseJ(
{$IFDEF Windows}
                      DalsiKrokAbortNMCallBackPr,
                      BylUserAbortAbortNMCallBackPr,
                      KeepWindowsAliveCallBackPr,
{$ENDIF}
                      TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                      MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost256FalseJ(
{$IFDEF Windows}
                     DalsiKrokAbortNMCallBackPr,
                     BylUserAbortAbortNMCallBackPr,
                     KeepWindowsAliveCallBackPr,
{$ENDIF}
                     TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                     MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
    end;
end;



procedure TransformujRastr2J(
{$IFDEF Windows}
                                 DalsiKrokAbortNMCallBackPr,
                                 BylUserAbortAbortNMCallBackPr,
                                 KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                 TransfPtr             : PTransformace;
                                 IY, IX                : longInt;
{$IFDEF Windows}
                           const JmenoNovehoSouboru    : TPathStr;
{$ELSE}
                           const JmenoNovehoSouboru    : PathStr;
{$ENDIF}
                                 fSt                   : PPRStreamRas;
                                 Head                  : TypHeader;
                                 MinYn, MinXn, cyN, cxN: extended;
                                 iyN, ixN              : longInt;
                             var EscDone               : boolean
{$IFNDEF Windows}
                                                                  ;
                                 Procenta                 : TProcentaPtr
{$ENDIF}
                                                                          );

var
  fN: PPWStream;
  m: integer;
{$IFDEF Windows}
  Retezec1, Retezec2: array[0..255] of char;
{$ENDIF}

begin
  EscDone := false;

  if iyN mod 8 <> 0 then
    m := succ(iyN shr 3)
  else
    m := iyN shr 3;

  iyN := m shl 3;

  fN := New(PPWStream,Init(JmenoNovehoSouboru, 0, m, TopolHeaderSize, 65000));
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  with Head do
  begin
    xRasMin := MinXn;
    yRasMin := MinYn;
    xRasMax := MinXn + pred(ixN) * cxN;
    yRasMax := MinYn + pred(iyN) * cyN;
    Rows    := ixN;
    Cols    := iyN;
    Zoom    := 0;
  end;

  fN^.PisHeader(Head);
  if fN^.Status <> 0 then
  begin
    Dispose(fN, Done);
    exit;
  end;

  if UrciNatoceni(TransfPtr, MinYn, MinXn, cyN, iyN) then
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin2TrueJ(
{$IFDEF Windows}
                   DalsiKrokAbortNMCallBackPr,
                   BylUserAbortAbortNMCallBackPr,
                   KeepWindowsAliveCallBackPr,
{$ENDIF}
                   TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                   MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost2TrueJ(
{$IFDEF Windows}
                  DalsiKrokAbortNMCallBackPr,
                  BylUserAbortAbortNMCallBackPr,
                  KeepWindowsAliveCallBackPr,
{$ENDIF}
                  TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                  MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
    end
  else
    with TransfPtr^ do
    begin
{$IFDEF Windows}
      LoadString(HInstance, 621, Retezec1, 256);
      LoadString(HInstance, 622, Retezec2, 256);
      if (StrIComp(NazevTransformace, Retezec1{'PODOBN 2D'}) = 0) or
         (StrIComp(NazevTransformace, Retezec2{'AFINN  2D'}) = 0) then
{$ELSE}
      if (NazevTransformace = Vyb_Podobn2D{'PODOBN 2D'}) or (NazevTransformace = Vyb_Afinn2D{'AFINN  2D'}) then
{$ENDIF}
        Afin2FalseJ(
{$IFDEF Windows}
                    DalsiKrokAbortNMCallBackPr,
                    BylUserAbortAbortNMCallBackPr,
                    KeepWindowsAliveCallBackPr,
{$ENDIF}
                    TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                    MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
      else
        Ost2FalseJ(
{$IFDEF Windows}
                   DalsiKrokAbortNMCallBackPr,
                   BylUserAbortAbortNMCallBackPr,
                   KeepWindowsAliveCallBackPr,
{$ENDIF}
                   TransfPtr, IY, IX, JmenoNovehoSouboru, fSt, fN,
                   MinYn, MinXn, cyN, cxN, iyN, ixN, EscDone
                     {$IFNDEF Windows}, Procenta{$ENDIF})
    end;
end;



end.
