Uses OWindows,WinProcs,ODialogs,{WWLink,} WinTypes,Tablet;


{$R XYWIN.RES}


type
    TXYApp = object(TApplication)
             Procedure InitMainWindow; virtual;
             Function IdleAction:boolean; virtual;
             end;

    PXYWin = ^TXYWin;
    TXYWin = object(TWindow)
             SMys,STablet,SDruh:PStatic;
             TabX,TabY:double;
             TabTl:word;
             Tablet:PTablet;
             Preteceni:boolean;
             Constructor Init(AParent:PWindowsObject; ATitle:Pchar);
             Procedure GetWindowClass(var AWndClass: TWndClass); virtual;
             Destructor Done; virtual;

             Procedure Polling;

             Procedure WMMouseMove(var Msg:TMessage); virtual wm_First+wm_MouseMove;
             Procedure CMStart(var Msg:TMessage); virtual cm_first+101;
             Procedure CMStop (var Msg:TMessage); virtual cm_first+102;
             Procedure CMReset(var Msg:TMessage); virtual cm_first+103;
             Procedure CMOVOn (var Msg:TMessage); virtual cm_first+104;
             Procedure CMOVOff(var Msg:TMessage); virtual cm_first+105;
             end;

Procedure TXYWin.CMOVOn;
begin
     preteceni:=True;
end;

Procedure TXYWin.CMOVOff;
begin
     preteceni:=False;
end;

Procedure TXYWin.CMStart;
begin
     Tablet^.StartScan;
end;

Procedure TXYWin.CMStop;
begin
     Tablet^.StopScan;
end;

Procedure TXYWin.CMReset;
begin
     Tablet^.InitHS;
end;

Constructor TXYWin.Init;
var i:word;
begin
     inherited Init(AParent,ATitle);
     Attr.Menu:=LoadMenu(HInstance,'MAINMENU');
     Attr.H:=180; Attr.W:=200;
     Tablet:=New(PTablet,Init);
     If Tablet^.OpenPort then SDruh:=New(PStatic,Init(@self,-1,'Tablet OK',10,85,150,105,20))
     else begin
          Dispose(Tablet,Done); Tablet:=nil;
          SDruh:=New(PStatic,Init(@self,-1,'Tablet nepripojen',10,85,150,105,20));
          For i:=0 to 4 do EnableMenuItem(Attr.Menu,101+i,mf_grayed);
     end;
     SMys:=New(PStatic,Init(@self,-1,'   0     0',10,5,150,24,10));
     STablet:=New(PStatic,Init(@self,-1,'0000,0000,0',10,30,150,49,13));
     Preteceni:=False;
end;

Procedure TXYWin.GetWindowClass;
begin
    Inherited GetWindowClass(AWndClass);
    AWndClass.hIcon := LoadIcon(HInstance, 'MAINICON');
end;

Procedure TXYWin.WMMouseMove;
var s1,s2:string[25];
begin
     str(LoWord(Msg.lParam):4,s1);
     str(HiWord(Msg.lParam):4,s2);
     s1:=s1+' '+s2+#0;
     SMys^.SetText(@s1[1]);
end;

Destructor TXYWin.Done;
begin
     If Tablet<>nil then Dispose(Tablet,Done);
     inherited Done;
end;

Procedure TXYWin.Polling;
var x,y:double;
    t:word;
    s,s1:string;
begin
     If Preteceni then Exit;
     If Tablet<>nil then
     begin
          Tablet^.Polling;
          If Tablet^.PosledniXYT(x,y,t) then
          begin
               str(x:6:1,s);
               str(y:6:1,s1); s:=s+','+s1;
               str(t,s1); s:=s+','+s1+#0;
               STablet^.SetText(@s[1]);
          end;
     end;
end;

Procedure TXYApp.InitMainWindow;
begin
     MainWindow:=New(PXYWin,Init(nil,'XY'));
end;

Function TXYApp.IdleAction:boolean;
begin
     PXYWin(MainWindow)^.Polling;
     IdleAction:=True;
end;

var XY:TXYApp;
begin
     XY.Init('XY');
     XY.Run;
     XY.Done;
end.
